<?php

/*
	Plugin Name: Del.icio.us Tag-Cloud II
	Plugin URI: http://jowra.com/journal/wordpress-plugin-delicious-tag-cloud-ii/
	Description: Provides a tag-cloud build from your del.icio.us-tags. Original, more general code by Chris Lott (chris.lott@gmail.com - http://www.chrislott.org/)
	Author: John Wrana (Jowra)
	Author URI: http://jowra.com/
	Version: 0.2
*/

function del_tagcloud($del_username, $del_password, $gradation = 9) {

	$url = 'https://api.del.icio.us/v1/tags/get';

	$tagarray = array('');
	
	$ch = curl_init($url);
	
	curl_setopt($ch, CURLOPT_USERPWD, "$del_username:$del_password");
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 4);
	curl_setopt($ch, CURLOPT_TIMEOUT, 8);
	curl_setopt($ch, CURLOPT_USERAGENT, 'del.icio.us tag cloud II - http://jowra.com/');
	
	$apitags = curl_exec($ch);
	
	curl_close($ch);
	
	preg_match_all('/tag count="(\\d*)" tag="(.*)"\s*\/\>/', $apitags, $tags);
	
	$i = 0;
	foreach ($tags[2] as $tag => $name) {
		$tagarray[$name] =  $tags[1][$i];
		$i++;
	}
	
	foreach ($tagarray as $tag => $count) {
		$tagarray[$tag] = round($count = 100 * log($count + 2));
	}
	
	$max = max($tagarray);
	$min = min($tagarray);
	$diff = $max - $min;
	$delta = $diff / $gradation;
	
	for ($i = 1; $i <= $gradation; $i++) {
		$thresh[$i] = round($min + $i * $delta);
	}
	
	$output = '<div class="cloud">';
	
	$drop_first = 1;
	
	foreach ($tagarray as $tag => $tagcount) {
		if ( !$drop_first ) {
			$class = 1;
			for ($i = 1; $i <= $gradation; $i++) {
				if ($tagcount > $thresh[$i])
					$class = $i;
					continue;
			}
			$output .= '<a title="' . $del_username . '@del.icio.us - tag: ' . $tag . '" href="http://del.icio.us/' . $del_username . '/' . $tag . '" class="tag' . $class . '">' . $tag . '</a>' . "\n";
		}
		$drop_first = 0;
	}
	$output .= '</div>';
	echo $output;
}

?>